###################################################
### chunk number 1: 
###################################################
#line 71 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
library(nsRFA)


###################################################
### chunk number 2: 
###################################################
#line 82 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
data(hydroSIMN)


###################################################
### chunk number 3:  eval=FALSE
###################################################
## #line 86 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
## ls()
## help(hydroSIMN)


###################################################
### chunk number 4: 
###################################################
#line 108 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
Dm <- parameters[,"Dm"]
logDm <- log(Dm)
sqrtDm <- sqrt(Dm)
sqrt3Dm <- Dm^(1/3)


###################################################
### chunk number 5: 
###################################################
#line 115 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
attributes <- parameters[,-c(1,2)]
logattributes <- log(attributes[,-c(7:9)])
mixedattributes <- cbind(attributes, logattributes[,1])
 names(mixedattributes) <- c(names(attributes), "lnAm")


###################################################
### chunk number 6: nontrasfregr
###################################################
#line 123 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nontrasfregr <- bestlm(Dm, mixedattributes, kmax=3, nbest=4); nontrasfregr


###################################################
### chunk number 7: 
###################################################
#line 128 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nregr <- dim(nontrasfregr$subselect)[1]
diagn <- data.frame(matrix(NA, nrow=nregr, ncol=2)); names(diagn) <- c("RMSE","RMSEjk")
for (i in 1:nregr){
 f <- paste("Dm ~", paste(colnames(nontrasfregr$subselect)[nontrasfregr$subselect[i,]], collapse=" + "))
 regr <- lm(f, mixedattributes)
 diagn[i,1] <- RMSE.lm(regr)
 diagn[i,2] <- RMSEjk.lm(regr)
}
diagn


###################################################
### chunk number 8: multregr
###################################################
#line 141 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
multregr <- bestlm(logDm, logattributes, kmax=3, nbest=4); multregr


###################################################
### chunk number 9: 
###################################################
#line 145 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nregr <- dim(multregr$subselect)[1]
diagn <- data.frame(matrix(NA, nrow=nregr, ncol=2)); names(diagn) <- c("RMSE","RMSEjk")
for (i in 1:nregr){
 f <- paste("logDm ~", paste(colnames(multregr$subselect)[multregr$subselect[i,]], 
                             collapse=" + "))
 regr <- lm(f, logattributes)
 fitt <- regr$fitted.values
 crossval <- jackknife1.lm(regr)
 diagn[i,1] <- RMSE(Dm, exp(fitt))
 diagn[i,2] <- RMSE(Dm, exp(crossval))
}
diagn


###################################################
### chunk number 10: trasfregr_log
###################################################
#line 161 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
trasfregr_log <- bestlm(logDm, mixedattributes, kmax=3, nbest=4); trasfregr_log


###################################################
### chunk number 11: 
###################################################
#line 164 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nregr <- dim(trasfregr_log$subselect)[1]
diagn <- data.frame(matrix(NA, nrow=nregr, ncol=2)); names(diagn) <- c("RMSE","RMSEjk")
for (i in 1:nregr){
 f <- paste("logDm ~", paste(colnames(trasfregr_log$subselect)[trasfregr_log$subselect[i,]], 
                             collapse=" + "))
 regr <- lm(f, mixedattributes)
 fitt <- regr$fitted.values
 crossval <- jackknife1.lm(regr)
 diagn[i,1] <- RMSE(Dm, exp(fitt))
 diagn[i,2] <- RMSE(Dm, exp(crossval))
}
diagn


###################################################
### chunk number 12: trasfregr_sqrt
###################################################
#line 179 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
trasfregr_sqrt <- bestlm(sqrtDm, mixedattributes, kmax=3, nbest=4); trasfregr_sqrt


###################################################
### chunk number 13: 
###################################################
#line 182 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nregr <- dim(trasfregr_sqrt$subselect)[1]
diagn <- data.frame(matrix(NA, nrow=nregr, ncol=2)); names(diagn) <- c("RMSE","RMSEjk")
for (i in 1:nregr){
 f <- paste("sqrtDm ~", paste(colnames(trasfregr_sqrt$subselect)[trasfregr_sqrt$subselect[i,]], 
                              collapse=" + "))
 regr <- lm(f, mixedattributes)
 fitt <- regr$fitted.values
 crossval <- jackknife1.lm(regr)
 diagn[i,1] <- RMSE(Dm, fitt^2)
 diagn[i,2] <- RMSE(Dm, crossval^2)
}
diagn


###################################################
### chunk number 14: trasfregr_sqrt3
###################################################
#line 197 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
trasfregr_sqrt3 <- bestlm(sqrt3Dm, mixedattributes, kmax=3, nbest=4); trasfregr_sqrt3


###################################################
### chunk number 15: 
###################################################
#line 200 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nregr <- dim(trasfregr_sqrt3$subselect)[1]
diagn <- data.frame(matrix(NA, nrow=nregr, ncol=2)); names(diagn) <- c("RMSE","RMSEjk")
for (i in 1:nregr){
 f <- paste("sqrt3Dm ~", paste(colnames(trasfregr_sqrt3$subselect)[trasfregr_sqrt3$subselect[i,]], 
                               collapse=" + "))
 regr <- lm(f, mixedattributes)
 fitt <- regr$fitted.values
 crossval <- jackknife1.lm(regr)
 diagn[i,1] <- RMSE(Dm, fitt^3)
 diagn[i,2] <- RMSE(Dm, crossval^3)
}
diagn


###################################################
### chunk number 16: 
###################################################
#line 218 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
bestregr <- lm(sqrt3Dm ~ S2000 + IT + lnAm, mixedattributes); bestregr


###################################################
### chunk number 17: 
###################################################
#line 221 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
summary(bestregr)


###################################################
### chunk number 18: 
###################################################
#line 226 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
vif.lm(bestregr)
cor(bestregr$model[-1])


###################################################
### chunk number 19: 
###################################################
#line 231 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
prt.lm(bestregr)


###################################################
### chunk number 20: bestregression
###################################################
#line 237 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
bestregr <- lm(logDm ~ Hm + NORD + IB, mixedattributes)
bestregr
summary(bestregr)


###################################################
### chunk number 21: 
###################################################
#line 242 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
prt.lm(bestregr)


###################################################
### chunk number 22: 
###################################################
#line 245 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
vif.lm(bestregr)
cor(bestregr$model[-1])


###################################################
### chunk number 23: 
###################################################
#line 250 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
p_norm <- A2_GOFlaio(bestregr$residuals, dist="NORM"); p_norm


###################################################
### chunk number 24: 
###################################################
#line 254 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
rmse <- RMSE(Dm, exp(bestregr$fitted.values))

predicted <- jackknife1.lm(bestregr)
rmse_jk <- RMSE(Dm, exp(predicted))


###################################################
### chunk number 25: 
###################################################
#line 265 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
op <- par(mfrow=c(2,2))
 plot(bestregr$fitted.values, bestregr$residuals, xlab="Fitted", ylab="Residuals")
  abline(0,0,lty=3)

 normplot(bestregr$residuals, xlab="Residuals")
 
 plot(parameters[,c("Dm")], exp(bestregr$fitted.values), xlab="Originals", ylab="Fitted")
  abline(0,1,lty=3)
  intervals <- predinterval.lm(bestregr)
  intervals <- intervals[order(intervals[,1]),]
 
 plot(parameters[,c("Dm")], exp(predicted), xlab="Originals", ylab="Predicted")
  abline(0,1,lty=3)
  lines(exp(intervals[,c(1,2)]),lty=2)
  lines(exp(intervals[,c(1,3)]),lty=2)
par(op)


###################################################
### chunk number 26: 
###################################################
#line 304 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
D <- annualflows["dato"][,]
y <- annualflows["anno"][,]
cod <- annualflows["cod"][,]


###################################################
### chunk number 27: 
###################################################
#line 314 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
consistencyplot(y,cod)


###################################################
### chunk number 28: 
###################################################
#line 327 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
ni <- tapply(D, cod, length)
annualflows15 <- annualflows[unsplit(ni, cod)>=15,]
parameters15 <- parameters[ni>=15,]
D15 <- annualflows15["dato"][,]
cod15 <- annualflows15["cod"][,]


###################################################
### chunk number 29: 
###################################################
#line 336 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
LM15 <- data.frame(t(sapply(split(D15, cod15), Lmoments)))


###################################################
### chunk number 30: 
###################################################
#line 343 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
plot(LM15[3:5])


###################################################
### chunk number 31: 
###################################################
#line 360 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
Lspace.HWvsAD()
points(LM15[,4:3])


###################################################
### chunk number 32: 
###################################################
#line 375 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
set.seed(10)


###################################################
### chunk number 33: 
###################################################
#line 378 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
D15adim <- D15/unsplit(tapply(D15, cod15, mean), cod15)
HWs <- HW.tests(D15adim, cod15)[1]; HWs


###################################################
### chunk number 34: 
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
bestlm(LM15[,"lcv"], parameters15[,3:16], kmax=3)


###################################################
### chunk number 35: 
###################################################
#line 388 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
bestlm(as.numeric(AD.dist(D15,cod15)), data.frame(apply(parameters15[,3:16], 2, dist)), 
       kmax=3)


###################################################
### chunk number 36: mantel.test
###################################################
#line 395 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
Y <- AD.dist(D15,cod15)
X <- data.frame(apply(parameters15[,c("Hm","Ybar")],2,dist))
datamantel <- cbind(as.numeric(Y),X)
regrmantel <- lm(Y ~ Hm + Ybar, datamantel)
#summary(regrmantel)
mantel.lm(regrmantel, Nperm=100)


###################################################
### chunk number 37: clusteranalysis
###################################################
#line 405 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
param <- parameters15[c("Hm","Ybar")]
n <- dim(param)[1]; k <- dim(param)[2]
param.norm <- (param - matrix(mean(param), nrow=n, ncol=k, byrow=TRUE))/
              matrix(sd(param), nrow=n, ncol=k, byrow=TRUE)


###################################################
### chunk number 38: 
###################################################
#line 411 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
set.seed(10)


###################################################
### chunk number 39: 
###################################################
#line 414 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
nclusters=1
while (max(HWs) > 2.1) {
 nclusters <- nclusters+1
 clusters <- traceWminim(param.norm, nclusters)
 indclusters <- unsplit(clusters, cod15)
 HWs <- rep(NA, nclusters)
 for (i in unique(clusters)) {
  HWs[i] <- HW.tests(D15adim[indclusters==i], cod15[indclusters==i])[1]
 }
 print(HWs)
} 


###################################################
### chunk number 40: 
###################################################
#line 432 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
regLM15 <- t(sapply(split(D15adim, indclusters), Lmoments))[,3:5]
regLM15


###################################################
### chunk number 41: 
###################################################
#line 438 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
for (i in 1:nclusters) {
 print(regionalLmoments(D15adim[indclusters==i], cod15[indclusters==i])[3:5])
}


###################################################
### chunk number 42: 
###################################################
#line 449 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
op <- par(mfrow=c(2,2))
 plot(parameters15[c("Hm","Ybar")], col=clusters, pch=clusters, cex=0.6,
      main="Clusters in the space of classification variables", cex.main=1, font.main=1)
  grid()
  points(tapply(parameters15["Hm"][,], clusters, mean), 
         tapply(parameters15["Ybar"][,], clusters, mean),
         col=c(1:nclusters), pch=c(1:nclusters))
 legend("topleft", paste("clust ",c(1:nclusters)), 
        col=c(1:nclusters), pch=c(1:nclusters), bty="n")

 plot(parameters15[c("Xbar","Ybar")], col=clusters, pch=clusters, cex=0.6,
      main="Clusters in geographical space", cex.main=1, font.main=1)
  grid()

 plot(LM15[,4:3], pch=clusters, col=clusters, cex=0.6,
      main="Clusters in L-moments space", cex.main=1, font.main=1)
  points(regLM15[,2:1], col=c(1:nclusters), pch=c(1:nclusters))
  grid()

 plot(LM15[,4:5], pch=clusters, col=clusters, cex=0.6,
      main="Clusters in L-moments space", cex.main=1, font.main=1)
  points(regLM15[,2:3], col=c(1:nclusters), pch=c(1:nclusters))
  grid()
par(op)


###################################################
### chunk number 43: 
###################################################
#line 490 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
Lmoment.ratio.diagram()
 points(regLM15[,2:3], col=c(1:nclusters), pch=c(1:nclusters))
 legend("bottomleft",paste("clust ", c(1:nclusters)), 
        col=c(1:nclusters), pch=c(1:nclusters), bty="n")


###################################################
### chunk number 44: GOFlaio2004
###################################################
#line 529 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
for (i in 1:nclusters) {
  GOFA2_P3 <- A2_GOFlaio(D15adim[indclusters==i], dist="P3")
  cat(paste("\np(A2) for Cluster ", i, ":\n", sep=""))
  print(GOFA2_P3)
}


###################################################
### chunk number 45: 
###################################################
#line 539 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
paramgamma=NULL
for (i in 1:nclusters) {
 paramgamma[[i]] <- par.gamma(1, regLM15[i,1], regLM15[i,2])
 cat(paste("\nCluster",i,":\n"))
 print(format(paramgamma[[i]][1:3]))
}


###################################################
### chunk number 46: 
###################################################
#line 548 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
for (i in 1:nclusters) {
 cat(paste("\nCluster",i,":\n"))
 print(format(par2mom.gamma(paramgamma[[i]]$xi, 
       paramgamma[[i]]$beta, paramgamma[[i]]$alfa)))
}


###################################################
### chunk number 47: GrowthCurves1.png
###################################################
#line 558 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
png(file="GrowthCurves1.png", height=960, width=960, res=144, pointsize=9)


###################################################
### chunk number 48: 
###################################################
#line 561 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
op <- par(mfrow=c(2,2))
 for (i in 1:nclusters) {
  FF <- F.gamma(D15adim[indclusters==i], paramgamma[[i]]$xi, 
                paramgamma[[i]]$beta, paramgamma[[i]]$alfa)
  regionalplotpos(D15adim[indclusters==i], cod15[indclusters==i], 
                  xlab=paste("cluster", i),
                  main="Empirical distributions", cex.main=1, font.main=1)
  lines(sort(D15adim[indclusters==i]), sort(FF))
  nomi <- names(clusters)[clusters==i]
  legend("bottomright", legend=nomi, pch=c(1:length(nomi)), 
         col=c(1:length(nomi)), bty="n", cex=.9)
 }
par(op)


###################################################
### chunk number 49: 
###################################################
#line 576 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
dev.off()


###################################################
### chunk number 50: GrowthCurves2.png
###################################################
#line 586 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
png(file="GrowthCurves2.png", height=960, width=960, res=144, pointsize=9)


###################################################
### chunk number 51: 
###################################################
#line 589 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
op <- par(mfrow=c(2,2))
 for (i in 1:nclusters) {
  Fs <- seq(0.001,0.999,by=.001)
  regionalnormplot(D15adim[indclusters==i], cod15[indclusters==i], 
                   xlab=paste("cluster", i),
                   main="Empirical distributions", cex.main=1, font.main=1)
  normpoints(invF.gamma(Fs, paramgamma[[i]]$xi, paramgamma[[i]]$beta, 
                        paramgamma[[i]]$alfa), type="l")
  nomi <- names(clusters)[clusters==i]
  legend("bottomright", legend=nomi, pch=c(1:length(nomi)), 
         col=c(1:length(nomi)), bty="n", cex=.9)
 }
par(op)


###################################################
### chunk number 52: 
###################################################
#line 604 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
dev.off()


###################################################
### chunk number 53: 
###################################################
#line 617 "d:/Rcompile/CRANpkg/local/2.12/nsRFA/inst/doc/nsRFA_ex01.Rnw"
spess=c(1, 1.5, 2, 1.3)
Fs <- seq(0.001,0.999,by=.001)
lognormplot(D15adim, line=FALSE, type="n", )
for (i in 1:nclusters) {
 qq <- invF.gamma(Fs, paramgamma[[i]]$xi, paramgamma[[i]]$beta, 
                  paramgamma[[i]]$alfa)
 normpoints(qq, type="l", lty=i, col=i, lwd=spess[i])
}
legend("bottomright", paste("cluster ", c(1:nclusters)), 
       col=c(1:nclusters), lty=c(1:nclusters), lwd=spess, bty="n")


